"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const input_1 = __importDefault(require("./input"));
const months_1 = require("./const/months");
const days_1 = require("./const/days");
const years_1 = require("./const/years");
const YEARS = years_1.getYears();
function DatePicker(props) {
    const { onChange, date, icon, fontStyle, containerStyle } = props;
    const [month, setMonth] = react_1.useState();
    const [day, setDay] = react_1.useState();
    const [year, setYear] = react_1.useState();
    function fillDate(date) {
        let day = date.getUTCDate().toString();
        let year = YEARS.find(y => y.value == date.getFullYear());
        let dayOption;
        let monthCurrent = months_1.Months.find(mon => mon.value == date.getUTCMonth() + 1);
        if (parseInt(day) < 10) {
            day = "0" + day;
        }
        dayOption = {
            value: day,
            label: day
        };
        setDay(dayOption);
        if (monthCurrent) {
            setMonth(monthCurrent);
        }
        if (year) {
            setYear(year);
        }
    }
    function getDaysInMonth(month, year) {
        return new Date(year, month, 0).getDate();
    }
    ;
    function getAllDays() {
        if (!year || !month)
            return [];
        let numberOfDays = getDaysInMonth(parseInt(month.value.toString()), parseInt(year.value.toString()));
        return days_1.getDays(numberOfDays);
    }
    react_1.useEffect(() => {
        let currentDate;
        if (date) {
            currentDate = new Date(date);
        }
        else {
            currentDate = new Date();
        }
        fillDate(currentDate);
    }, []);
    react_1.useEffect(() => {
        function valueChanged() {
            let date = `${year === null || year === void 0 ? void 0 : year.value}/${month === null || month === void 0 ? void 0 : month.value}/${day === null || day === void 0 ? void 0 : day.value}`;
            onChange(date);
        }
        valueChanged();
    }, [day, year, month]);
    return (<react_native_1.View style={Object.assign({ flexDirection: 'row', width: '100%', padding: 10 }, containerStyle)}>
            
            <input_1.default placeholder="No Selected" options={months_1.Months} option={month || null} fontStyle={fontStyle} style={{ flex: 3 }} onSelected={value => { setMonth(value); }} icon={icon}/>

            <input_1.default placeholder="No Selected" style={{ flex: 1.5 }} options={getAllDays()} option={day || null} onSelected={value => { setDay(value); }} icon={icon}/>

            <input_1.default placeholder="No Selected" style={{ flex: 2 }} options={YEARS} option={year || null} onSelected={value => { setYear(value); }} icon={icon}/>
          
        </react_native_1.View>);
}
exports.default = DatePicker;
//# sourceMappingURL=index.js.map